<template>
  <div>
    <div class="titleBox">
      <PageTitle title="重点人审批">
        <el-popover placement="bottom" :visible="visible" :width="400" trigger="click">
          <template #reference>
            <el-button type="primary" @click="(visible = !visible), (visiblefp = false)" size="small">布控申请</el-button>
          </template>
          <div class="flex just-center">
            <el-button size="small" type="primary" v-for="it in D_GS_BK_SQLX" :key="it.dm" @click="handleApplication(it)" >{{ it.zdmc }}</el-button>
          </div>
        </el-popover>
        <el-popover placement="bottom" :visible="visiblefp" :width="400" trigger="click">
          <template #reference>
            <el-button size="small" type="primary" @click="(visiblefp = !visiblefp), (visible = false)" >指定分配</el-button>
          </template>
          <div>
            <el-input readonly v-model="obj.fpmc" @click="chooseUserVisible = true" placeholder="请选择民警"></el-input>
            <div class="flex just-center mt10">
              <el-button @click="(visiblefp = false), (obj = {})" size="small">取消</el-button>
              <el-button type="primary" @click="handlefp" size="small">分配</el-button>
            </div>
          </div>
        </el-popover>
        <el-button size="small" type="primary" @click="handleZxs">转线索</el-button>
        <el-button size="small" type="primary" @click="handleMove">移交管控</el-button>
      </PageTitle>
    </div>
    <!-- 搜索 -->
    <div ref="searchBox">
      <Search :searchArr="searchConfiger" @submit="onSearch" />
    </div>
    <!-- 表格 -->
    <div class="tabBox">
      <MyTable
        :tableData="pageData.tableData"
        :tableColumn="pageData.tableColumn"
        :tableHeight="pageData.tableHeight"
        :key="pageData.keyCount"
        :tableConfiger="pageData.tableConfiger"
        :controlsWidth="pageData.controlsWidth"
        @chooseData="chooseData"
      >
        <template #ryxx="{ row }">
          <div class="flex">
            <img src="" alt="" style="width: 80px;height: 90px;" />
            <ul class="tl ml10" style="flex:1 0 0">
              <li class="one_text_detail">姓名：{{ row.ryXm }}</li>
              <li class="flex one_text_detail">性别：<DictTag :tag="false" :value="row.ryXb" :options="D_BZ_XB" /></li>
              <li class="flex one_text_detail">籍贯：<DictTag :tag="false" :value="row.ryJg" :options="D_BZ_XZQHDM"/></li>
              <li class="one_text_detail">身份证：{{ row.rySfzh }}</li>
              <li class="one_text_detail">出生日期：{{ row.ryCsrq }}</li>
              <li class="flex one_text_detail">民族：<DictTag :tag="false" :value="row.ryMz" :options="D_BZ_MZ" /></li>
            </ul>
          </div>
        </template>
        <template #bqList="{ row }">
         <ul >
            <li class="one_text_detail marks mb4" :key="index" v-for="(item, index) in row.bqList">{{ item.bqMc }}({{ item.bqFz || 0  }} 分) </li> 
          </ul>
        </template>

        <template #jzxx="{ row }">
          <div class="flex one_text_detail">户籍地区划：<DictTag :tag="false" :value="row.hjdQh" :options="D_BZ_XZQHDM" /></div>
          <div class="flex one_text_detail">户籍派出所：{{ row.hjdPcsmc }}</div>
          <div class="flex one_text_detail">户籍地详址：{{ row.hjdXz }}</div>
        </template>
        <template #gxdw="{ row }">
          <div class="flex one_text_detail">管辖单位：{{ row.gxSsbmmc }}</div>
          <div class="flex">人员级别：<DictTag :tag="false" :value="row.zdrRyjb" :options="D_GS_ZDR_RYJB"/> </div>
          <div class="flex one_text_detail">管控原因：{{ row.zdrLkyy }}</div>
          <div class="flex">管控状态：<DictTag :tag="false" :value="row.zdrBkZt" :options="D_GS_ZDR_BK_ZT" /></div>
        </template>
        <template #zdrCzzt="{ row }">
          <DictTag :tag="false" :value="row.zdrCzzt" :options="D_GS_ZDR_CZZT" />
        </template>
        <template #xtSjzt="{ row }">
          <div> {{ row.xtSjzt == 0 ? "注销" : row.xtSjzt == 1 ? "正常" : "封存" }}</div>
        </template>
        <template #zdrZt="{ row }">
          <DictTag :tag="false" :value="row.zdrZt" :options="D_GS_ZDQT_ZT" />
        </template>

        <!-- 操作 -->
        <template #controls="{ row }">
          <el-popover placement="left" :visible="row.visible" :width="400" trigger="manual">
            <template #reference>
              <el-link size="small" type="warning" v-if="row.zdrZt == '02'" @click="row.visible = !row.visible,chooseRow.id = row.id">审核</el-link>
            </template>
            <el-form :model="chooseRow" ref="elRowForm" :inline="true" label-width="100px" :rules="rules">
              <el-form-item label="是否通过" prop="sftg" class="mt10 mb10" style="width: 100%;">
                <MOSTY.Select filterable v-model="chooseRow.sftg" :dictEnum="D_BZ_SF" width="100%" clearable  placeholder="请选择是否通过"/>
              </el-form-item>
              <el-form-item label="不通过原因" prop="shBtgyy" v-if="chooseRow.sftg == 0" style="width: 100%;">
                <MOSTY.Other style="width: 100%;" clearable v-model="chooseRow.shBtgyy" type="textarea" placeholder="请输入不通过原因"/>
              </el-form-item>
            </el-form>
            <div class="flex just-center mt10">
              <el-button @click.stop="cancelRow(row)">取消</el-button>
              <el-button type="primary"  @click.stop="handleSend(row)"  v-loading="btnloading">确定</el-button>
            </div>
          </el-popover>

          <el-popover placement="left" :visible="row.visible1" :width="400" trigger="manual">
            <template #reference>
              <el-link size="small" type="primary" v-if="row.zdrZt == '04'" @click="row.visible1 = !row.visible1,chooseRow.id = row.id">审批</el-link>
            </template>
            <el-form :model="chooseRow" ref="elRowForm1" :inline="true" label-width="100px" :rules="rules">
              <el-form-item label="是否通过" prop="sftg" class="mt10 mb10" style="width: 100%;">
                <MOSTY.Select filterable v-model="chooseRow.sftg" :dictEnum="D_BZ_SF" width="100%" clearable  placeholder="请选择是否通过"/>
              </el-form-item>
              <el-form-item label="不通过原因" prop="spBtgyy" v-if="chooseRow.sftg == 0" style="width: 100%;">
                <MOSTY.Other style="width: 100%;" clearable v-model="chooseRow.spBtgyy" type="textarea" placeholder="请输入不通过原因"/>
              </el-form-item>
            </el-form>
            <div class="flex just-center mt10">
              <el-button @click.stop="cancelRowSp(row)">取消</el-button>
              <el-button type="primary"  @click.stop="handleSendSp(row)"  v-loading="btnloading">确定</el-button>
            </div>
          </el-popover>

          <el-link size="small" type="primary" @click="addEdit('detail', row)" >详情</el-link>
        </template>
      </MyTable>
      <Pages
        @changeNo="changeNo"
        @changeSize="changeSize"
        :tableHeight="pageData.tableHeight"
        :pageConfiger="{
          ...pageData.pageConfiger,
          total: pageData.total
        }"
      ></Pages>
    </div>
    <!-- 详情 -->
    <AddForm ref="addFormDiloag" @updateDate="getList" :dic="{D_GS_ZDR_RYJB,D_BZ_XB,D_BZ_MZ,D_BZ_XZQHDM,D_GS_ZDR_BK_ZT,D_GS_ZDR_CZZT,D_GS_BQ_ZL,D_GS_BQ_LB,D_GS_BQ_LX,D_GS_ZDR_YJDJ,D_GS_BK_SSJZ}"/>
    <!-- 选择用户 -->
    <ChooseUser v-model="chooseUserVisible" @choosedUsers="handleUserSelected" :roleIds="roleIds"/>
    <!-- 转线索 -->
    <ZxsForm v-if="showzxs" ref="zxsDilof" @change="getList" :dic="{D_BZ_SF,D_BZ_XB,D_GS_XS_LY,D_BZ_SSZT,D_GS_XS_LX,D_GS_XS_QTLX }"></ZxsForm>
  </div>
</template>

<script setup>
import * as MOSTY from "@/components/MyComponents/index";
import { ElMessage } from "element-plus";
import ChooseUser from "@/components/ChooseList/ChooseUser/index.vue";
import ZxsForm from "../mpvPeo/components/zxsForm.vue";
import PageTitle from "@/components/aboutTable/PageTitle.vue";
import MyTable from "@/components/aboutTable/MyTable.vue";
import Pages from "@/components/aboutTable/Pages.vue";
import Search from "@/components/aboutTable/Search.vue";
import AddForm from "../mpvPeo/components/addForm.vue";
import { qcckGet, qcckPost } from "@/api/qcckApi.js";
import { reactive, ref, onMounted, getCurrentInstance, nextTick } from "vue";
const { proxy } = getCurrentInstance();
const { D_GS_ZDQT_ZT,D_GS_ZDR_RYJB, D_BZ_XB, D_BZ_MZ, D_BZ_XZQHDM, D_GS_ZDR_BK_ZT, D_GS_ZDR_CZZT, D_GS_BQ_ZL, D_GS_BQ_LB, D_GS_BQ_LX, D_GS_ZDR_YJDJ, D_GS_BK_SSJZ, D_GS_BK_SQLX, D_BZ_SF, D_GS_XS_LY, D_BZ_SSZT, D_GS_XS_LX, D_GS_XS_QTLX } = proxy.$dict("D_GS_ZDQT_ZT","D_GS_ZDR_RYJB","D_BZ_XB","D_BZ_MZ","D_BZ_XZQHDM","D_GS_ZDR_BK_ZT","D_GS_ZDR_CZZT","D_GS_BQ_ZL","D_GS_BQ_LB","D_GS_BQ_LX","D_GS_ZDR_YJDJ","D_GS_BK_SSJZ","D_GS_BK_SQLX","D_BZ_SF","D_GS_XS_LY","D_BZ_SSZT","D_GS_XS_LX","D_GS_XS_QTLX");
const obj = ref({});
const showzxs = ref(false);
const zxsDilof = ref();
const show = ref(false);
const addFormDiloag = ref();
const searchBox = ref(); //搜索框
const chooseUserVisible = ref(false); //审批流程
const ids = ref([]);
const choosList = ref([]);
const visible = ref(false);
const visiblefp = ref(false);
const chooseRow = ref({})
const btnloading = ref(false)
const elRowForm = ref()
const elRowForm1 = ref()
const rules = reactive({
  sftg: [{ required: true, message: "请选择是否通过", trigger: "change" }],
  shBtgyy: [{ required: true, message: "请输入不通过原因", trigger: "blur" }],
  spBtgyy: [{ required: true, message: "请输入不通过原因", trigger: "blur" }]
});

const searchConfiger = ref([
  {
    label: "姓名",
    prop: "ryXm",
    placeholder: "请输入姓名",
    showType: "input"
  },
  {
    label: "身份证",
    prop: "rySfzh",
    placeholder: "请输入身份证",
    showType: "input"
  },
  {
    label: "户籍地",
    prop: "hjdXz",
    placeholder: "请输入户籍地",
    showType: "input"
  },
  {
    label: "人员级别",
    prop: "zdrRyjb",
    placeholder: "请输入人员级别",
    showType: "select",
    options: D_GS_ZDR_RYJB
  },
  {
    label: "人员级别",
    prop: "zdrRyjb",
    placeholder: "请输入人员级别",
    showType: "select",
    options: D_GS_ZDR_RYJB
  },
]);
const queryFrom = ref({});
const pageData = reactive({
  tableData: [],
  keyCount: 0,
  tableConfiger: {
    rowHieght: 61,
    showSelectType: "checkBox",
    loading: false
  },
  total: 0,
  pageConfiger: {
    pageSize: 20,
    pageCurrent: 1
  },
  controlsWidth: 120,
  tableColumn: [
    { label: "重点人员信息", prop: "ryxx", showSolt: true,width:300,showOverflowTooltip:true },
    { label: "户籍居住信息", prop: "jzxx", showSolt: true,width:300, },
    { label: "标签", prop: "bqList", showSolt: true ,width:200,showOverflowTooltip:true},
    { label: "管辖单位", prop: "gxdw", showSolt: true,width:300, },
    { label: "处置状态", prop: "zdrCzzt", showSolt: true },
    { label: "状态", prop: "xtSjzt", showSolt: true },
    { label: "审核状态", prop: "zdrZt", showSolt: true },
  ]
});

onMounted(() => {
  getList();
  tabHeightFn();
});

// 搜索
const onSearch = (val) => {
  queryFrom.value = { ...val };
  pageData.pageConfiger.pageCurrent = 1;
  getList();
};

const changeNo = (val) => {
  pageData.pageConfiger.pageCurrent = val;
  getList();
};
const changeSize = (val) => {
  pageData.pageConfiger.pageSize = val;
  getList();
};

// 获取列表
const getList = () => {
  pageData.tableConfiger.loading = true;
  let data = { ...pageData.pageConfiger, ...queryFrom.value,zdrZt:'02' };
  qcckGet(data, "/mosty-gsxt/tbGsxtZdry/selectPage").then((res) => {
    pageData.tableData = res.records || [];
    pageData.total = res.total;
    pageData.tableConfiger.loading = false;
  }).catch(() => {
    pageData.tableConfiger.loading = false;
  });
};


const chooseData = (data) => {
  ids.value = Array.isArray(data) ? data.map((item) => item.id) : [];
  choosList.value = Array.isArray(data) ? data : [];
};
// 选择申请数据数据
const handleApplication = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要布控的重点人");
  qcckPost({ ids: ids.value }, "/mosty-gsxt/tbGsxtZdry/addBksq").then(() => {
    ElMessage.success("申请成功");
    visible.value = false;
    getList();
  }).catch(() => {
    ElMessage.error("布控申请失败");
  });
};

const handleUserSelected = (val) => {
  obj.value.fpmc = val[0].userName;
  obj.value.fpid = val[0].id;
};

// 处理分配
const handlefp = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要布控的重点人");
  qcckPost({ ids: ids.value, uid: obj.value.fpid },"/mosty-gsxt/tbGsxtZdry/addGkmj").then(() => {
    ElMessage.success("分配成功");
    visible.value = false;
    visiblefp.value = false;
    getList();
  }).catch(() => {
    ElMessage.error("分配失败");
  });
};

// 移交管控
const handleMove = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要移交管控的重点群体");
  proxy.$confirm("是否确定移交？", "警告", { type: "warning" }).then(() => {
    qcckPost({ ids: ids.value }, "/mosty-gsxt/tbGsxtZdry/addSfyj").then(() => {
      ElMessage.success("移交管控成功");
      getList();
    }).catch(() => {
      ElMessage.error("移交管控失败");
    });
  });
};

// 转线索
const handleZxs = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要转线索的重点群体");
  showzxs.value = true;
  nextTick(() => {
    zxsDilof.value.init(choosList.value);
  });
};


const cancelRow = (row) => {
  row.visible = false;
  chooseRow.value = {};
  btnloading.value = false;
  elRowForm.value.resetFields()
};

// 审核
const handleSend = (val) =>{
  elRowForm.value.validate((valid) => {
    if(!valid) return;
    btnloading.value = true;
    qcckPost(chooseRow.value, "/mosty-gsxt/tbGsxtZdry/updateSh").then(() => {
      proxy.$message({ type: "success", message: "审核成功" });
      cancelRow(val)
      getList();
    }).catch(()=>{
      btnloading.value = false;
    });
  })
}

// 审批
const cancelRowSp = (row) =>{
  row.visible1 = false;
  chooseRow.value = {};
  btnloading.value = false;
  elRowForm1.value.resetFields()
}
// 审批
const handleSendSp = (val) =>{
  elRowForm1.value.validate((valid) => {
    if(!valid) return;
    btnloading.value = true;
    qcckPost(chooseRow.value, "/mosty-gsxt/tbGsxtZdry/updateSp").then(() => {
      proxy.$message({ type: "success", message: "审批成功" });
      cancelRowSp(val);
      getList();
    }).catch(()=>{
      btnloading.value = false;
    });
  })
}


//新增编辑
const addEdit = (type, row) => {
  show.value = true;
  nextTick(()=>{
    addFormDiloag.value.init(type, row);
  })
};

// 表格高度计算
const tabHeightFn = () => {
  pageData.tableHeight = window.innerHeight - searchBox.value.offsetHeight - 250;
  window.onresize = function () {
    tabHeightFn();
  };
};
</script>

<style lang="scss" scoped>
.marks{
  padding: 0 4px;
  white-space: nowrap;
  background: #73acf1;
  border-radius: 4px;
  color: #fff;
}
</style>

<style>
.el-loading-mask {
  background: rgba(0, 0, 0, 0.5) !important;
}

</style>
